# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%bcond_without repolib

%global namedversion %{version}

Name:           microemulator
Version:        2.0.4
Release:        1%{?dist}
Epoch:          0
Summary:        Java 2 Micro Edition (J2ME) CLDC/MIDP Emulator
License:        LGPLv2.1
Group:          Development/Java
URL:            http://www.microemu.org/
# svn export -r 2507 http://microemu.googlecode.com/svn/tags/microemulator_2_0_4/ microemulator-2.0.4 && tar cjf microemulator-2.0.4.tar.bz2 microemulator-2.0.4
Source0:        microemulator-2.0.4.tar.bz2
Patch0:         microemulator-site.patch
Patch1:         microemulator-pom.patch
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-eclipse
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-site
BuildRequires:  maven2-plugin-surefire
BuildRequires:  objectweb-asm
BuildRequires:  junit
%if 0
groupId=com.pyx4me:artifactId=cldcunit-se:version=${pyx4meVersion}:scope=provided:optional=
groupId=com.pyx4me:artifactId=cldcunit:version=${pyx4meVersion}:scope=test:optional=
groupId=com.pyx4me:artifactId=cldcunit-se:version=${pyx4meVersion}:scope=provided:optional=
groupId=com.pyx4me:artifactId=cldcunit:version=${pyx4meVersion}:scope=test:optional=
groupId=com.pyx4me:artifactId=j2me-maven-plugin:version=${pyx4meVersion}
groupId=com.pyx4me:artifactId=proguard-maven-plugin:version=${pyx4meVersion}

groupId=de.avetana-gmbh:artifactId=avetana-bluetooth:version=1.3.12a:scope=:optional=

groupId=de.tarent.maven.plugins:artifactId=maven-pkg-plugin:version=2.1.0-SNAPSHOT


groupId=iphone:artifactId=jocstrap:version=1.0.2549-8:scope=:optional=
groupId=iphone:artifactId=straptease:version=0.7:scope=:optional=
groupId=iphone:artifactId=uicaboodle:version=1.0.2475-2:scope=:optional=


groupId=net.sf.bluecove:artifactId=bluecove:version=2.0.1:scope=:optional=

groupId=net.sf.jour:artifactId=jour-instrument:version=:scope=test:optional=true
groupId=net.sf.jour:artifactId=jour-maven-plugin:version=${jourVersion}

groupId=org.codehaus.mojo:artifactId=webstart-maven-plugin:version=

groupId=org.mortbay.jetty:artifactId=maven-jetty-plugin:version=6.1.1

groupId=sun:artifactId=applet-jsobject:version=:scope=:optional=true

groupId=swt:artifactId=swt:version=3.2.1:scope=system:optional=
%endif
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-source
BuildRequires:  maven-surefire-provider-junit
BuildRequires:  maven2
BuildRequires:  maven2-plugin-dependency
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-project-info-reports
BuildRequires:  maven2-plugin-resources
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
This is Java 2 Micro Edition (J2ME) CLDC/MIDP Emulator. Allows demonstration
MIDlet (MIDP/CLDC) based applications in web browser applet, also can be run as
standalone java application.

FIXME: Currently this package provides only the cldc interfaces.

%package javadoc
Group:          Development/Documentation
Summary:        Javadoc for %{name}
Requires:       jpackage-utils

%description javadoc
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q
%patch0 -p1 -b .sav0
%patch1 -p1 -b .sav1

%build
export MAVEN_REPO_LOCAL=`pwd`/.m2/repository
export ALT_DEPLOYMENT_REPOSITORY=oss-releases::default::file:`pwd`/maven2-brew
export MAVEN_OPTS="-Xms1g -Xmx1g"
pushd microemu-cldc
%{_bindir}/mvn-jpp -e -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DaltDeploymentRepository=${ALT_DEPLOYMENT_REPOSITORY} -Dmaven.test.skip=true deploy javadoc:aggregate
popd

%install
%{__rm} -rf %{buildroot}

pushd maven2-brew

# jars
%{__mkdir_p} %{buildroot}%{_javadir}/%{name}
%{__cp} -p org/microemu/microemu-cldc/%{namedversion}/microemu-cldc-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}/microemu-cldc-%{namedversion}.jar
(cd %{buildroot}%{_javadir}/%{name} && for jar in *-%{namedversion}*; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} -e "s|-%{namedversion}||g"`; done)

# poms
%{__mkdir_p} %{buildroot}%{_datadir}/maven2/poms
%{__cp} -p org/microemu/microemu-cldc/%{namedversion}/microemu-cldc-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-microemu-cldc.pom

popd

# depmaps
%add_to_maven_depmap org.microemu microemu-cldc %{namedversion} JPP/%{name} microemu-cldc

# javadoc
mkdir -p %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
pushd microemu-cldc
cp -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
popd
ln -s %{name}-%{namedversion} %{buildroot}%{_javadocdir}/%{name}

%if %with repolib
mkdir -p %{buildroot}%{_javadir}/repository.jboss.com
cp -pr maven2-brew %{buildroot}%{_javadir}/repository.jboss.com
%endif

%clean
%{__rm} -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%doc CHANGES COPYING COPYING-AL-2.0 COPYING-LGPL-2.1 CREDITS README read-me-developer.txt TODO
%dir %{_javadir}*/%{name}
%exclude %dir %{_javadocdir}/%{name}
%{_javadir}*/%{name}/microemu-cldc-%{namedversion}.jar
%{_javadir}*/%{name}/microemu-cldc.jar
%{_datadir}/maven2/poms/JPP.%{name}-microemu-cldc.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{namedversion}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %dir %{_javadocdir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Thu Aug 18 2011 David Walluck <dwalluck@redhat.com> 0:2.0.4-1
- release
